<template>
  <div class="min-h-screen">
    <div class="max-w-[100rem] px-4 sm:px-6 mx-auto lg:py-16 lg:px-12 min-h-screen">
        <div class="lg:col-span-2 mt-16">
          <div v-if="loading" role="status" class="space-y-8 animate-pulse md:space-y-0 md:space-x-8 rtl:space-x-reverse md:flex md:items-center">

              <div role="status" class="max-w-sm animate-pulse">
                <div class="h-2.5 bg-gray-200 rounded-full dark:bg-gray-700 w-48 mb-4"></div>
                <div class="h-2 bg-gray-200 rounded-full dark:bg-gray-700 max-w-[360px] mb-2.5"></div>
                <div class="h-2 bg-gray-200 rounded-full dark:bg-gray-700 mb-2.5"></div>
                <div class="h-2 bg-gray-200 rounded-full dark:bg-gray-700 max-w-[330px] mb-2.5"></div>
                <div class="h-2 bg-gray-200 rounded-full dark:bg-gray-700 max-w-[300px] mb-2.5"></div>
                <div class="h-2 bg-gray-200 rounded-full dark:bg-gray-700 max-w-[360px]"></div>
                <span class="sr-only">Loading...</span>
              </div>


            </div>
          <div v-else>
            <div class="flex w-full flex-wrap lg:flex-nowrap">
              <article class="w-1/2 lg:sticky lg:start-0 lg:top-12">
                <div class="max-w-full lg:sticky lg:start-0 lg:top-12">
                  <NuxtLink :to="'/article/' + firstArticle.News_id">
                    <div class="zoom-container rounded-3xl">
                      <img class="rounded-3xl transition-transform duration-300 ease-in-out zoom" :src="firstArticle.pictureURL" alt="" />
                    </div>
                  </NuxtLink>
                  <div class="p-5">
                    <NuxtLink :to="'/article/' + firstArticle.News_id">
                      <h5 class="mb-2 text-2xl font-bold tracking-tight text-gray-900 hover:underline">
                        {{ firstArticle.title }}
                      </h5>
                    </NuxtLink>
                    <div class="mb-3 font-normal text-gray-700" v-html="firstArticle.description">
                    </div>
                    <p>Source: medium.com</p>
                  </div>
                </div>
              </article>
              <div class="w-1/2 ml-16">
                <h3 class="mb-10 text-3xl font-extrabold leading-none tracking-tight text-primary-700 md:text-4xl dark:text-white">Recent articles</h3>
                <div class="grid xl:grid-cols-1 lg:gap-5 lg:grid-cols-2">
                  <article v-for="(article, index) in recentArticles" :key="index" class="py-5 sm:flex lg:flex-col xl:flex-row xl:items-center ">
                    <NuxtLink class=" w-full sm:w-5/12 lg:w-full xl:w-5/12" :to="'/article/' + article.News_id">
                      <div class="zoom-container rounded-3xl overflow-hidden min-w-72 h-36 border-2 border-gray-50">
                        <img alt="What a Four Day Week Actually Looks Like" loading="lazy" decoding="async" data-nimg="fill"
                             class="rounded-3xl transition-transform duration-300 ease-in-out zoom w-full h-full object-cover"
                             :src="article.pictureURL">
                      </div>
                    </NuxtLink>
                    <div class="dHctb3JkZXItMQ dHctbXQtNQ dHctdy1mdWxs dHctcHgtMg sm:dHctbXQtMA sm:dHctbWF4LXctc20 sm:dHctcGwtMA sm:dHctcHItNQ lg:dHctb3JkZXItMg lg:dHctbXQtNA xl:dHctbWwtNQ xl:dHctbXQtMA xl:dHctZmxleC0x">
                      <NuxtLink :to="'/article/' + article.News_id">
                        <h3 class="text-decoration-thickness font-medium leading-normal tracking-normal text-xl ml-5 hover:underline">
                          {{ article.title }}
                        </h3>
                      </NuxtLink>
                      <p class="ml-5 mt-5">Source: medium.com</p>
                    </div>
                  </article>
                </div>
              </div>
            </div>
            <div class="w-full mt-16 lg:mt-36">
              <h3 class="mb-10 text-3xl font-extrabold leading-none tracking-tight text-primary-700 md:text-4xl dark:text-white">Current articles</h3>
              <div class="flex flex-wrap lg:flex-nowrap">
                <div class="w-2/3">
                    <div class="grid grid-cols-1 md:grid-cols-2 gap-4">
                        <article v-for="(article, index) in currentArticles" :key="index">
                          <div class="max-w-full">
                            <NuxtLink :to="'/article/' + article.News_id">
                              <div class="zoom-container rounded-3xl border-2 border-gray-50 h-72">
                                <img class="rounded-3xl transition-transform duration-300 w-full h-full ease-in-out zoom object-cover" :src="article.pictureURL" alt="" />
                              </div>
                            </NuxtLink>
                            <div class="p-5">
                              <NuxtLink :to="'/article/' + article.News_id">
                                <h5 class="mb-2 text-2xl font-bold tracking-tight text-gray-900 hover:underline">
                                  {{ article.title }}
                                </h5>
                              </NuxtLink>
                              <div class="mb-3 font-normal text-gray-700" v-html="article.description">
                              </div>
                              <p>Source: medium.com</p>
                            </div>
                          </div>
                        </article>
                    </div>
                </div>
                <div class="w-1/3 ml-10">
                  <sidebar />
                </div>
              </div>
            </div>
            <section class="bg-gray-100 flex items-center justify-center relative mt-16 lg:mt-32 h-[50rem]">
              <a href="#" class="w-full h-full object-cover">
                <img :src="onArticle.pictureURL" alt="Nuclear Power Station" class="w-full h-full object-cover rounded-2xl">
              </a>
              <div class="max-w-4xl mx-auto bg-white shadow-md rounded-lg overflow-hidden lg:absolute lg:-bottom-32 h-72">
                <div class="p-6 w-full h-full">
                  <div class="w-2/3 h-full text-center mx-auto flex items-center">
                    <a href="#">
                      <h1 class="text-2xl text-center font-bold mt-2 hover:underline">{{ onArticle.title }}</h1>
                    </a>
                  </div>
                </div>
              </div>
            </section>
            <div class="w-full h-32"></div>
            <div class="flex w-full flex-wrap lg:flex-nowrap">
              <div class="w-2/3 ml-16 mt-16 lg:mt-32">
                <div class="grid xl:grid-cols-1 lg:gap-5 lg:grid-cols-2">
                  <article v-for="(article, index) in box1Article" :key="index" class="py-5 sm:flex lg:flex-col xl:flex-row xl:items-center ">
                    <NuxtLink class=" w-full sm:w-5/12 lg:w-full xl:w-5/12" :to="'/article/' + article.News_id">
                      <div class="zoom-container rounded-3xl overflow-hidden w-72 h-36 border-2 border-gray-50">
                        <img alt="What a Four Day Week Actually Looks Like" loading="lazy" decoding="async" data-nimg="fill"
                             class="rounded-3xl transition-transform duration-300 ease-in-out zoom w-72 h-full object-cover"
                             :src="article.pictureURL">
                      </div>
                    </NuxtLink>
                    <div class="dHctb3JkZXItMQ dHctbXQtNQ dHctdy1mdWxs dHctcHgtMg sm:dHctbXQtMA sm:dHctbWF4LXctc20 sm:dHctcGwtMA sm:dHctcHItNQ lg:dHctb3JkZXItMg lg:dHctbXQtNA xl:dHctbWwtNQ xl:dHctbXQtMA xl:dHctZmxleC0x">
                      <NuxtLink :to="'/article/' + article.News_id">
                        <h3 class="text-decoration-thickness font-medium leading-normal tracking-normal text-xl ml-5 hover:underline">
                          {{ article.title }}
                        </h3>
                      </NuxtLink>
                      <p class="ml-5 mt-5">Source: medium.com</p>
                    </div>
                  </article>
                </div>
              </div>
              <div class="w-1/3 mt-16 lg:mt-32 lg:col-span-1 rounded-2xl lg:bg-gradient-to-r lg:from-gray-50 lg:via-transparent lg:to-transparent dark:from-neutral-800">
                  <div class="space-y-6">
                    <article class="py-5 sm:flex lg:flex-col xl:flex-row xl:items-center ">
                      <NuxtLink class=" w-full sm:w-5/12 lg:w-full xl:w-5/12" :to="'/article/' + firstArticle.News_id">
                        <div class="zoom-container rounded-3xl overflow-hidden w-36 h-36 border-2 border-gray-50">
                          <img alt="What a Four Day Week Actually Looks Like" loading="lazy" decoding="async" data-nimg="fill"
                               class="rounded-3xl transition-transform duration-300 ease-in-out zoom w-full h-full object-cover"
                               :src="firstArticle.pictureURL">
                        </div>
                      </NuxtLink>
                      <div class="dHctb3JkZXItMQ dHctbXQtNQ dHctdy1mdWxs dHctcHgtMg sm:dHctbXQtMA sm:dHctbWF4LXctc20 sm:dHctcGwtMA sm:dHctcHItNQ lg:dHctb3JkZXItMg lg:dHctbXQtNA xl:dHctbWwtNQ xl:dHctbXQtMA xl:dHctZmxleC0x">
                        <NuxtLink :to="'/article/' + firstArticle.News_id">
                          <h3 class="text-decoration-thickness font-medium leading-normal tracking-normal text-xl ml-5 text-left">
                            {{ firstArticle.title }}
                          </h3>
                        </NuxtLink>
                        <p class="ml-5 mt-5">Source: medium.com</p>
                      </div>
                    </article>
                  </div>
              </div>
            </div>
          </div>
        </div>
    </div>
  </div>
</template>

<script lang="ts" setup>
import {useNuxtApp} from "#app";
import type {Api} from "~/types/api";
import moment from "moment/moment";

const nuxtApp = useNuxtApp()
const $api = nuxtApp.$api as Api

const links = [{
  label: 'Home',
  icon: 'i-heroicons-home'
}]

const loading = ref(false)
const data = ref(false)
const error = ref('')

async function loadData () {
  try {
    loading.value = true
    data.value = await $api.getNews()
  } catch (err) {
    error.value = err.message
  } finally {
    loading.value = false
  }
}

const firstArticle = computed(() => {
  return data.value.length > 0 ? data.value[0] : [];
})

const recentArticles = computed(() => {
  return data.value.length > 1 ? data.value.slice(1, 9) : [];
});

const currentArticles = computed(() => {
  return data.value.length > 9 ? data.value.slice(10, 20) : [];
});

const onArticle = computed(() => {
  return data.value.length >= 20 ? data.value[20] : [];
});

const box1Article = computed(() => {
  return data.value.length >= 21 ? data.value.slice(21, 28) : [];
});

onMounted(() => {
  loadData()
})
</script>

<style>
.zoom-container {
  overflow: hidden;
}
.zoom:hover {
  transform: scale(1.1); /* Zoom in effect */
}
</style>